/* SCCS  %W%---%E%--%U% */
//
//	nsl_icon_stim_data.c
//

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_icon_stim_data::nsl_icon_stim_data(nsl_input_data* l) : nsl_stim_data(l)
{
	set_type("icon_stim_data");

	icon = 0;
}
nsl_icon_stim_data::~nsl_icon_stim_data()
{
}

int nsl_icon_stim_data::proc()
{
	nsl_input_data* Q;
	float k;

	if (m_parent != NULL)
		Q = (nsl_input_data*) m_parent->get_m_parent();
	else
		cmd_error("nsl_icon_stim_datax: NULL parent");
	
	if (Q != NULL)
	{
		k = (Q->get_input_layer()->get_overlapfg() == 1) ? 1.0 : 0.0;

        	Q->elem() = k*Q->elem() + icon->elem();
	}
	else
		cmd_error("nsl_icon_stim_data: NULL parent layer");
	
	return 1;
}

int nsl_icon_stim_data::print(ostream& out) const
{
	return print_icon_stim_data(out);
}
int nsl_icon_stim_data::print_icon_stim_data(ostream& out) const
{
 	if (icon != NULL)
		icon->print(out);
	else
		cmd_out("NULL icon");

	print_stim_data(out);

	return 1;
}
int nsl_icon_stim_data::print_status(ostream& out) const
{
	return print_icon_stim_data_status(out);
}
int nsl_icon_stim_data::print_icon_stim_data_status(ostream& out) const
{
	return print_stim_data_status(out);
}
 
