/* SCCS  %W%---%E%--%U% */
//
//	nsl_stim_type_data.C
//

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_stim_type_data::nsl_stim_type_data(int sfg,int fg,int rfg) : 
	nsl_data_layer(sfg,fg,rfg)
{
	init_stim_type_data();
}
nsl_stim_type_data::nsl_stim_type_data(const char* str,nsl_model* m,int sfg,int fg,
	int rfg) : nsl_data_layer("stim_type_data",str,m,sfg,fg,rfg)
{
	init_stim_type_data();
}
nsl_stim_type_data::nsl_stim_type_data(const char* str,const stim_type_enum val,
	nsl_model* m,int sfg,int fg,int rfg) : 
	nsl_data_layer("stim_type_data",str,m,sfg,fg,rfg)
{
	init_stim_type_data();
	sval = val;
}
nsl_stim_type_data::nsl_stim_type_data(const nsl_stim_type_data& a,int sfg,int fg,
	int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_stim_type_data();
	sval = a.get_value();
}

// nsl_stim_type_data destructors

nsl_stim_type_data::~nsl_stim_type_data()
{
}

// init

int nsl_stim_type_data::init_stim_type_data()
{
	sval = NSL_BLOCK;
	return 1;
}

// nsl_stim_type_data set values

stim_type_enum nsl_stim_type_data::set_value(const stim_type_enum val)
{
	sval = val;
	return sval;
}

// nsl_stim_type_data assignment

stim_type_enum nsl_stim_type_data::operator=(const nsl_stim_type_data& a)
{
	sval = a.get_value();
	return sval;
}
stim_type_enum nsl_stim_type_data::operator=(const stim_type_enum val)
{
	sval = val;
	return sval;
}

// print

int nsl_stim_type_data::print_stim_type_data_status(ostream& out) const
{
	print_data_layer_status(out);
	return 1;
}
int nsl_stim_type_data::print_status(ostream& out) const
{
	print_stim_type_data_status(out);
	return 1;
}
int nsl_stim_type_data::print_stim_type_data(ostream& out) const
{
	print_data_layer(out);
	out <<  sval << "\n";
	out.flush();
	return 1;
}
int nsl_stim_type_data::print(ostream& out) const
{
	print_stim_type_data(out);
	return 1;
}

int nsl_stim_type_data::reset_stim_type_data(nsl_buffer* buf)
{
	if (buf == NULL)
		sval = NSL_BLOCK;
//	else
//		*buf >> sval;

	return 1;
}
int nsl_stim_type_data::reset(nsl_buffer* buf)
{
	reset_stim_type_data(buf);
	return 1;
}

int nsl_stim_type_data::write_stim_type_data(nsl_buffer& buf)
{
	buf << sval;
	return 1;
}
int nsl_stim_type_data::write(nsl_buffer& buf)
{
	write_stim_type_data(buf);
	return 1;
}
int nsl_stim_type_data::read_stim_type_data(nsl_buffer& buf)
{
	nsl_string str;
	buf >> str;

	if (strcmp(str,"NSL_BLOCK") == 0)
		sval = NSL_BLOCK;
	else if (strcmp(str,"NSL_ICON") == 0)
		sval = NSL_ICON;
	else
		cmd_error("stim_type_data:read: BAD string: ",str);

	return 1;
}
int nsl_stim_type_data::read(nsl_buffer& buf)
{
	read_stim_type_data(buf);
	return 1;
}


