/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_mult_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_2<NslNumType,NslTypeId>_mult_library.h
//
/*
extern	nsl_num_2<NslNumType,NslTypeId> 	operator^(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator^(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator^(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator^(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator^(const NslNumType,const nsl_num_2<NslNumType,NslTypeId>&);

extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);

extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);

extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
*/
// matrix pointwise multiplication

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (matrix) " << a.get_name() << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator^ ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return a;
	}

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (matrix) " << a.get_name() << " ^ (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (matrix) " << a.get_name() << " ^ (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (matrix) " << a.get_name() << " ^ (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (NslNumType) " << a << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (NslNumType) " << a << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (NslNumType) " << a << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (matrix) " << a.get_name() << " ^ (data) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);
	
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const NslFloat0& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (data) " << a.get_name() << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const NslDouble0& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (data) " << a.get_name() << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator^(const NslInt0& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator^\n";
        cout << "// (data) " << a.get_name() << " ^ (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() * b[i][j];

	return c;
}
// matrix pointwise multiplication

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLmult ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return a;
	}

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const nsl_num_2<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a * b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLmult(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() * b[i][j];

	return c;
}

// mult_equal

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a[i][j] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a[i][j] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != outimax || ajmax != outjmax || 
		aimax != bimax || ajmax != bjmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a[i][j] * b[i][j];
}

// matrix conv
// fix for no allocation/deallocation of d

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& b,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int saimax = a.get_imax();
	int sbimax = b.get_imax();
	int sbjmax = b.get_jmax();

	int vec_type;
	int simax;
	int m;
	NslNumType val;

	val = 0;
	out = 0; // needed

	if ((vec_type = a.get_vec_type()) == 0)
	{
		simax = saimax + sbjmax - 1;
		nsl_num_2<NslNumType,NslTypeId> d(sbimax,simax);

		d.put_sector(b,0,saimax/2); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;	
			for (m = 0; m < saimax; m++)
			    val = val + a[m] * d[i][j+m];
			out[i][j] = val;
		   }
	}
	else
	{
		simax = saimax + sbimax - 1;
		nsl_num_2<NslNumType,NslTypeId> d(simax,sbjmax);

		d.put_sector(b,saimax/2,0); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;
			for (m = 0; m < saimax; m++)
			    val = val + a[m] * d[i+m][j];
			out[i][j] = val;
		   }
	}
}

// vec to mat

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& b,const nsl_num_0<NslNumType,NslTypeId>& a)
{
	int sbimax = b.get_imax();
	int simax = out.get_imax();
	int sjmax = out.get_jmax();

	if (b.get_vec_type() == 0) // ROW
	{
		if (sbimax != sjmax)
		{
			cmd_error("NSLmult_equal: Inconsistent matrix sizes");
			out.print_status(cerr);
			b.print_status(cerr);
		}

		for (int i = 0; i < simax; i++)
		   for (int j = 0; j < sjmax; j++)
			out[i][j] = a.get_data()*b[j];
	}
	else // COL
	{
		if (sbimax != simax)
		{
			cmd_error("NSLmult_equal: Inconsistent matrix sizes");
			out.print_status(cerr);
			b.print_status(cerr);
		}

		for (int i = 0; i < simax; i++)
		    for (int j = 0; j < sjmax; j++)
			out[i][j] = a.get_data()*b[i];
	}
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (bimax != outimax || bjmax != outjmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = a.get_data() * b[i][j];
}

// mult plus

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_plus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a[i][j] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_plus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a[i][j] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != outimax || ajmax != outjmax || 
		aimax != bimax || ajmax != bjmax)
	{
		cmd_error("NSLmult_plus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a[i][j] * b[i][j];
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (bimax != outimax || bjmax != outjmax)
	{
		cmd_error("NSLmult_plus: Inconsistent matrix sizes");
		out.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] + a.get_data() * b[i][j];
}

// mult minus

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_minus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a[i][j] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	if (aimax != outimax || ajmax != outjmax)
	{
		cmd_error("NSLmult_minus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a[i][j] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != outimax || ajmax != outjmax || 
		aimax != bimax || ajmax != bjmax)
	{
		cmd_error("NSLmult_minus: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a[i][j] * b[i][j];
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_2<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int outimax = out.get_imax();
	int outjmax = out.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (bimax != outimax || bjmax != outjmax)
	{
		cmd_error("NSLmult_minus: Inconsistent matrix sizes");
		out.print_status(cerr);
		b.print_status(cerr);
	}

	for (int i = 0; i < outimax; i++)
	   for (int j = 0; j < outjmax; j++)
		out[i][j] = out[i][j] - a.get_data() * b[i][j];
}


