/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_sub_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_2<NslNumType,NslTypeId>_sub_library.h
//
/*
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator-(const NslNumType,const nsl_num_2<NslNumType,NslTypeId>&);
*/

// matrix subtruction

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << " = - (matrix) ";
        cout << a.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = -a[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << a.get_name() << " - (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator- ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << a.get_name() << " - (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << a.get_name() << " - (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << a.get_name() << " - (NslNumType) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (NslNumType) " << a << " - (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (NslNumType) " << a << " - (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (NslNumType) " << a << " - (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (matrix) " << a.get_name() << " - (data) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator-\n";
        cout << "// (data) " << a.get_name() << " - (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() - b[i][j];

	return c;
}

// matrix subtraction

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = -a[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::,NSLsub ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const nsl_num_2<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const NslNumType a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a - b[i][j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] - b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsub(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c[i][j] = a.get_data() - b[i][j];

	return c;
}


