/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_conv_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_1<NslNumType,NslTypeId>_conv_library.h
//
/*
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator*(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator*(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator*(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator*(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator*(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);

extern nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_wrap(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLconv_copy(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int saimax = a.get_imax();
	int sbimax = b.get_imax();

	int simax = saimax + sbimax - 1;

	nsl_num_1<NslNumType,NslTypeId> c(sbimax);
	nsl_num_1<NslNumType,NslTypeId> d(simax);

	d.put_sector(b,saimax/2); 

	for (int i = 0; i < sbimax; i++)
	   {	
		NslNumType val = 0;
		for (int m = 0; m < saimax; m++)
			val = val + a[m] * d[i+m];
		c[i] = val;
	   }

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_1<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_1<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_1<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (NslNumTyper) " << a << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (NslNumTyper) " << a << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (NslNumTyper) " << a << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator*(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator*\n";
	cout << "// (data) " << a.get_name() << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// zero-edge vector convolution

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int saimax = a.get_imax();
	int sbimax = b.get_imax();

	int simax = saimax + sbimax - 1;

	nsl_num_1<NslNumType,NslTypeId> c(sbimax);
	nsl_num_1<NslNumType,NslTypeId> d(simax);

	d.put_sector(b,saimax/2); 

	for (int i = 0; i < sbimax; i++)
	   {	
		NslNumType val = 0;
		for (int m = 0; m < saimax; m++)
			val = val + a[m] * d[i+m];
		c[i] = val;
	   }
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const NslNumType a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_zero(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// wrap around convolution

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_wrap(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
      	int saimax = a.get_imax();
      	int sbimax = b.get_imax();

	int sm = saimax/2;

      	int simax = saimax + sbimax - 1;

      	nsl_num_1<NslNumType,NslTypeId> c(sbimax);
      	nsl_num_1<NslNumType,NslTypeId> d(simax);

      	d.put_sector(b,saimax/2); 

	int i,m;

      	for (i = sm-1; i >= 0; i--)
	   d[i] = b[(i-sm+sbimax)%sbimax];
      	for (i = sm+sbimax; i < simax; i++)
	   d[i] = b[(i-sm)%sbimax];

     	for (i = 0; i < sbimax; i++)
        {    
              NslNumType val = 0;
              for (m = 0; m < saimax; m++)
                      val = val + a[m] * d[i+m];
              c[i] = val;
        }

        return c;
}

// copy boundary convolution

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLconv_copy(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
      	int saimax = a.get_imax();
      	int sbimax = b.get_imax();

	int sm = saimax/2;

      	int simax = saimax + sbimax - 1;

      	nsl_num_1<NslNumType,NslTypeId> c(sbimax);
      	nsl_num_1<NslNumType,NslTypeId> d(simax);

      	d.put_sector(b,saimax/2); 

	int i,m;

      	for (i = sm-1; i >= 0; i--)
	   d[i] = b[0];
      	for (i = sm+sbimax; i < simax; i++)
	   d[i] = b[sbimax-1];

      	for (i = 0; i < sbimax; i++)
        {    
              NslNumType val = 0;
              for (m = 0; m < saimax; m++)
                      val = val + a[m] * d[i+m];
              c[i] = val;
        }

        return c;
}

