/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_div_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_1<NslNumType,NslTypeId>_div_library.h
//
/*
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator/(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator/(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator/(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator/(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator/(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/

// vector pointwise division

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (vector) " << a.get_name() << " / (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		if (b[i] != 0)
			c[i] = a[i] / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			a.print_status(cerr);
			b.print_status(cerr);
			return c;
		}			

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_1<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (vector) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_1<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (vector) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_1<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (vector) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			return c;
		}			

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			return c;
		}			

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			return c;
		}			

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (vector) " << a.get_name() << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		b.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a.get_data() / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			a.print_status(cerr);
			b.print_status(cerr);
			return c;
		}	

	return c;
}

// vector pointwise division

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLdiv(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::NSLdiv ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		if (b[i] != 0)
			c[i] = a[i] / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			a.print_status(cerr);
			b.print_status(cerr);
			return c;
		}	

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLdiv(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLdiv(const NslNumType a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			return c;
		}	

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLdiv(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		b.print_status(cerr);
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] / b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLdiv(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		if (b[i] != 0)
			c[i] = a.get_data() / b[i];
		else
		{
			cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			return c;
		}	

	return c;
}


