/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_expdecay_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_2<NslNumType,NslTypeId>_expdecay_library.h
//

//extern nsl_num_2<NslNumType,NslTypeId> NSLexpdecay(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLexpdecay(nsl_num_2<NslNumType,NslTypeId>& mat,nsl_num_0<NslNumType,NslTypeId>& kx1)
{
    int imax = mat.get_imax();
    int jmax = mat.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> q(imax,jmax);

    int i0 = mat.get_i0();
    int i1 = mat.get_i1();
    int j0 = mat.get_j0();
    int j1 = mat.get_j1();

	nsl_model* model = NULL; // NSL_SYSTEM->get_model();

	if (model == NULL)
	{
		cmd_error("NSLexxpdecay: NULL model");
		return mat;
	}

    num_type dt = model->getSimDelta();

    int i,j;
    num_type val;
        
        for (i=i0; i<=i1; i++)
            for (j=j0; j<=j1; j++)
            {
                val = exp(-dt/kx1.elem());
                q.elem(i,j) = val*mat.elem(i,j);
            }

	return q;
}

