/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_ramp_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_1<NslNumType,NslTypeId>_ramp_library.h                   */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/

// if a > 0 then a else 0

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a) 
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > (NslNumType) 0)
			c[i] = a[i];
		else
			c[i] = 0;
	return c;
}

// if a > b then a - b else 0

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > b[i])
			c[i] = a[i] - b[i];
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const float b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b;
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const int b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b;
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b.get_data();
		else
			c[i] = 0;
	return c;
}

// if a > b then a - b + y2 else y1

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b,
	const nsl_num_1<NslNumType,NslTypeId>& y1,const nsl_num_1<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("imax3: ",y1.get_imax());
		cmd_error("imax4: ",y2.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > b[i])
			c[i] = a[i] - b[i] + y2[i];
		else
			c[i] = y1[i];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLstep ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > b[i])
			c[i] = a[i] - b[i] + y2;
		else
			c[i] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b,const nsl_num_0<NslNumType,NslTypeId>& y1,
	const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLstep ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > b[i])
			c[i] = a[i] - b[i] + y2.get_data();
		else
			c[i] = y1.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,
	const float b, const float y1, const float y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b + y2;
		else
			c[i] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,
	const int b,const int y1, const int y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b + y2;
		else
			c[i] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLramp(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b,const nsl_num_0<NslNumType,NslTypeId>& y1,
	const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > b)
			c[i] = a[i] - b.get_data() + y2.get_data();
		else
			c[i] = y1.get_data();
	return c;
}
