/* SCCS  @(#)nsl_vector_conv_library.C	1.1---95/08/13--20:48:20 */
//
//	nsl_vector_conv_library.C
//
/*
# include "nsl_all_kernel_include.h"

nsl_vector operator*(const nsl_vector& a,const nsl_vector& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_vector  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int saimax = a.get_imax();
	int sbimax = b.get_imax();

	int simax = saimax + sbimax - 1;

	nsl_vector c(sbimax);
	nsl_vector d(simax);

	d.put_sector(b,saimax/2); 

	for (int i = 0; i < sbimax; i++)
	   {	
		num_type val = 0;
		for (int m = 0; m < saimax; m++)
			val = val + a[m] * d[i+m];
		c[i] = val;
	   }

	return c;
}
nsl_vector operator*(const nsl_vector& a,const num_type b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_vector  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (num_type) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_vector c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
nsl_vector operator*(const num_type a, const nsl_vector& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_vector  operator*\n";
	cout << "// (num_typer) " << a << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_vector c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
nsl_vector operator*(const nsl_vector& a,const nsl_data& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_vector  operator*\n";
	cout << "// (vector) " << a.get_name() << " * (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_vector c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
nsl_vector operator*(const nsl_data& a,const  nsl_vector& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_vector  operator*\n";
	cout << "// (data) " << a.get_name() << " * (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_vector c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// zero-edge vector convolution

nsl_vector NSLconv_zero(const nsl_vector& a,const nsl_vector& b)
{
	int saimax = a.get_imax();
	int sbimax = b.get_imax();

	int simax = saimax + sbimax - 1;

	nsl_vector c(sbimax);
	nsl_vector d(simax);

	d.put_sector(b,saimax/2); 

	for (int i = 0; i < sbimax; i++)
	   {	
		num_type val = 0;
		for (int m = 0; m < saimax; m++)
			val = val + a[m] * d[i+m];
		c[i] = val;
	   }
	return c;
}
nsl_vector NSLconv_zero(const nsl_vector& a,const num_type b)
{
	int aimax = a.get_imax();

	nsl_vector c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
nsl_vector NSLconv_zero(const num_type a, const nsl_vector& b)
{
	int bimax = b.get_imax();

	nsl_vector c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
nsl_vector NSLconv_zero(const nsl_vector& a,const nsl_data& b)
{
	int aimax = a.get_imax();

	nsl_vector c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
nsl_vector NSLconv_zero(const nsl_data& a,const  nsl_vector& b)
{
	int bimax = b.get_imax();

	nsl_vector c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// wrap around convolution

nsl_vector NSLconv_wrap(const nsl_vector& a,const nsl_vector& b)
{
      	int saimax = a.get_imax();
      	int sbimax = b.get_imax();

	int sm = saimax/2;

      	int simax = saimax + sbimax - 1;

      	nsl_vector c(sbimax);
      	nsl_vector d(simax);

      	d.put_sector(b,saimax/2); 

	int i,m;

      	for (i = sm-1; i >= 0; i--)
	   d[i] = b[(i-sm+sbimax)%sbimax];
      	for (i = sm+sbimax; i < simax; i++)
	   d[i] = b[(i-sm)%sbimax];

     	for (i = 0; i < sbimax; i++)
        {    
              num_type val = 0;
              for (m = 0; m < saimax; m++)
                      val = val + a[m] * d[i+m];
              c[i] = val;
        }

        return c;
}

// copy boundary convolution

nsl_vector NSLconv_copy(const nsl_vector& a,const nsl_vector& b)
{
      	int saimax = a.get_imax();
      	int sbimax = b.get_imax();

	int sm = saimax/2;

      	int simax = saimax + sbimax - 1;

      	nsl_vector c(sbimax);
      	nsl_vector d(simax);

      	d.put_sector(b,saimax/2); 

	int i,m;

      	for (i = sm-1; i >= 0; i--)
	   d[i] = b[0];
      	for (i = sm+sbimax; i < simax; i++)
	   d[i] = b[sbimax-1];

      	for (i = 0; i < sbimax; i++)
        {    
              num_type val = 0;
              for (m = 0; m < saimax; m++)
                      val = val + a[m] * d[i+m];
              c[i] = val;
        }

        return c;
}

*/