/* SCCS  @(#)xnsl_area_level_graph_vector.h	1.1---96/02/20--18:36:58 */
//
// 	xnsl_area_level_graph_vector.h
//

class xnsl_area_level_graph_vector : public xnsl_area_level_graph
{
	int _i0,_i1;		// vector range
	int _imax;		// vector size
	row_col_enum _vec_type;	// NSL_ROW, NSL_COL
public:
	xnsl_area_level_graph_vector(xnsl_display_canvas* = 0,nsl_layer* = 0);
	virtual ~xnsl_area_level_graph_vector();

	int init_area_level_graph_vector(nsl_layer*);

	void set_i0(int i) { _i0 = i; }
	void set_i1(int i) { _i1 = i; }
	void set_imax(int i) { _imax = i; }
	void set_vec_type(row_col_enum i) { _vec_type = i; }

	int get_i0() { return _i0; }
	int get_i1() { return _i1; }
	int get_imax() { return _imax; }
	row_col_enum get_vec_type() { return _vec_type; }

    virtual xnsl_widget *make_widget();

	virtual int clear();

        virtual int display();
        virtual int display_area_level_graph(xnsl_widget* = 0,int=0,int=0,int=10,int=10,
		num_type = 0.0, num_type = 1.0,int = 0, int = 0, int = 0);

	virtual int read_from_database();
	virtual int write_to_database();
	virtual int input(int = 0,int = 0, int = 0);
	virtual int output(int = 0,int = 0);
	virtual int print(ostream&) const;
};
/*
template<class NslType>
xnsl_area_level_graph_vector<NslType>::xnsl_area_level_graph_vector(
	xnsl_display_canvas* win,nsl_layer* m) : xnsl_area_level_graph<typeof(m)>(win)
{
    set_type("area_level_graph_vector");

	init_area_level_graph_vector(m);

}

template<class NslType>
xnsl_area_level_graph_vector<NslType>::~xnsl_area_level_graph_vector()
{
}

template<class NslType>
xnsl_widget * xnsl_area_level_graph_vector<NslType>::make_widget ()
{
        return new xnsl_area_level_graph_vector;
//		((xnsl_display_canvas*) m_parent,
//		(nsl_vector*) _layer);
}

template<class NslType>
int xnsl_area_level_graph_vector<NslType>::init_area_level_graph_vector(nsl_layer* m)
{
	if (m != NULL)
	{
		_layer = m;
		_imax = ((nsl_vector*) _layer)->get_imax();
		_layer0 = new nsl_vector(_imax);
		_i0 = 0;
		_i1 = _imax - 1;
		_vec_type = NSL_ROW;
 	}
//	else
//		cmd_error("xnsl_area_level_graph_vec: NULL layer");

	return 1;
}
template<class NslType>
int xnsl_area_level_graph_vector<NslType>::clear()
{
	(*((nsl_vector*) _layer0)) = 0;

	return 1;
}

template<class NslType>
int xnsl_area_level_graph_vector<NslType>::display()
{
//	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
    	display_area_level_graph(_widget,_wx0,_wy0,_wxs,_wys,_wymin,_wymax);
    	 
	return 1;
}
template<class NslType>
int xnsl_area_level_graph_vector<NslType>::display_area_level_graph(xnsl_widget* widget,
	int wx0,int wy0,int wxs,int wys,
	num_type wymin, num_type wymax,int,int,int) 
{
	int fg; // redraw fg
	int i,ni;
	num_type val,val0;

  	nsl_num_vector* m0 = ((nsl_vector*) _layer0);
	nsl_num_vector* m = ((nsl_vector*) _layer);

//	if ((fg = parent_canvas->get_redraw_fg()) == 1)
//		parent_canvas->set_redraw_fg(0);

	int pos = 0;

 	if (_vec_type == NSL_ROW)
	    for (i = wx0, ni = _i0; ni <= _i1; i = i + wxs, ni++)
	    {
			val = (*m)[ni];
	     	val0 = (*m0)[ni];
//AW99		if (val != val0) // || fg == 1) // new different values only
		{
//	 	    if (val < val0 || val < 0)
//				clear_area(widget,i+1,wy0+1,wxs-1,wys-1,pos);
		    display_area_level_graph_val(widget,i,wy0,wxs,wys,val,wymin,wymax,ni);
		}
	    }
	else
	    for (i = wy0, ni = _i0; ni <= _i1; i = i + wys, ni++)
	    {
		val = (*m)[ni];
	     	val0 = (*m0)[ni];
		if (val != val0 || fg == 1) // new different values only
		{
//	 	    if (val < val0 || val < 0)
//			clear_area_level(wx0,i,wxs,wys);
		    display_area_level_graph_val(widget,wx0,i,wxs,wys,val,wymin,wymax,ni);
		}
	    }

//	for (i = 0; i < _imax; i++)
//		(*m0)[i] = (*m)[i];
//
	*m0 = *m;

	return 1;
}

template<class NslType>
int xnsl_area_level_graph_vector<NslType>::read_from_database()
{
	xnsl_area_level_graph::read_from_database(); // read in new win sector

	return 1;
}
template<class NslType>
int xnsl_area_level_graph_vector<NslType>::write_to_database()
{
	xnsl_area_level_graph::write_to_database();

	return 1;
}
template<class NslType>
int xnsl_area_level_graph_vector<NslType>::input(int x_pos,int y_pos,int fg)
{

	return 1;
}
template<class NslType>
int xnsl_area_level_graph_vector<NslType>::output(int x_pos,int y_pos)
{
	return 1;
}

template<class NslType>
int xnsl_area_level_graph_vector<NslType>::print(ostream& out) const
{
	xnsl_area_level_graph::print(out);

	return 1;
}
*/